#include <exec/types.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include "locale_intern.h"
#include "private.h"

extern struct SignalSemaphore timezonelock;
extern char timezonename[256];

LONG TZGetSysTimeZone(STRPTR buf, LONG size, struct LocaleBase *LocaleBase)
{
  if (buf && size)
  {
    LONG zonenamelen;

    ObtainSemaphoreShared(&timezonelock);
    zonenamelen = strlen(timezonename);
    if (zonenamelen < size)
    {
      memcpy(buf, timezonename, zonenamelen);
      ReleaseSemaphore(&timezonelock);
      buf[zonenamelen] = '\0';
      return zonenamelen + 1;
    }
    else
      ReleaseSemaphore(&timezonelock);
  }
  SetIoErr(ERROR_LINE_TOO_LONG);
  return -1;
}
